/* This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// BusSchedWCEDlg.h : header file
//

#if !defined(AFX_BUSSCHEDWCEDLG_H__82141737_CBB5_4415_9E35_D984B817024E__INCLUDED_)
#define AFX_BUSSCHEDWCEDLG_H__82141737_CBB5_4415_9E35_D984B817024E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CBusSchedWCEDlg dialog

// Store pointers to the info for a route.
typedef struct {
    LPTSTR lpLine[ 10 ];
} sRouteInfo;

#define FIRST              0    /* Display first buses of day. */
#define NEXT              -1    /* Whether to display next buses, first buses or 'Later' buses. */
#define DIRECTION_OUT  false    /* Bus direction defines. */
#define DIRECTION_BACK  true

#define TIME_SEP_CHAR    ','    /* Character separating times in timetable. */


#define MAX_ROUTES        20    /* Maximum number of routes that app will handle. */
/* Route record offsets within group of ROUTE_REC_SIZE. */
#define ROUTE_NUM_OFFSET      0
#define FROM_OFFSET           1
#define TO_OFFSET             2
#define MF_OUT_TIMES_OFFSET   3
#define MF_BACK_TIMES_OFFSET  4
#define SA_OUT_TIMES_OFFSET   5
#define SA_BACK_TIMES_OFFSET  6
#define SU_OUT_TIMES_OFFSET   7
#define SU_BACK_TIMES_OFFSET  8
#define ROUTE_INFO_OFFSET     9
#define ROUTE_REC_SIZE       10    /* Number of records that constitute a route. */

#define TABLE_COLUMNS         3    /* Number of columns in timetable table. */

// INI file key and section names.
#define INI_SECTION          _T( "BusSched" )
#define INI_DBFILENAME       _T( "dbFileName" )
#define INI_ROUTE            _T( "uRoute" )
#define INI_DIRECTION        _T( "bDirection" )
#define INI_MINSFROMTERMINUS _T( "uMinsFromTerminus" )


class CBusSchedWCEDlg : public CDialog
{
// Construction
public:
	void DisplayError( CONST DWORD dwErrorNumber );
	CBusSchedWCEDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CBusSchedWCEDlg)
	enum { IDD = IDD_BUSSCHEDWCE_DIALOG };
	CListCtrl	m_Timetable;
	CComboBox	m_RouteCombo;
	CComboBox	m_DayCombo;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBusSchedWCEDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
protected:
	BOOL m_bFirstPaint;
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CBusSchedWCEDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeRouteCombo();
	afx_msg void OnSelchangeDayCombo();
	afx_msg void OnEarlierBtn();
	afx_msg void OnInfoBtn();
	afx_msg void OnLaterBtn();
	afx_msg void OnReverseBtn();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSelectTimetable();
	afx_msg void OnAboutbox();
	afx_msg void OnPreferences();
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void ReloadTimetable();
	BOOL ReadTimetableFile();
	void ClearRouteArray();
	UINT m_uMinsFromTerminus;
	UINT m_uNextBusOffset;
	UINT m_uRoute;
	INT m_nDayCombo;
	BOOL bDirection;
	CString m_dbFileName;
	LPTSTR m_lpDbInfo;
	DWORD m_dwDbFileLength;
	LPTSTR m_lpdbFileData;
    // An array of structs which point to route info.
	sRouteInfo m_aRoutes[ MAX_ROUTES ];
};

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BUSSCHEDWCEDLG_H__82141737_CBB5_4415_9E35_D984B817024E__INCLUDED_)
